package net.nevet5gi.buzzbot.commands;

import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.interactions.commands.build.CommandData;
import net.nevet5gi.buzzbot.BuzzBot;
import net.nevet5gi.buzzbot.Config;
import net.nevet5gi.buzzbot.commands.utils.CommandContext;
import net.nevet5gi.buzzbot.commands.utils.ICommand;
import net.nevet5gi.buzzbot.commands.utils.ISlashCommand;

public class PingCmd implements ICommand, ISlashCommand {
    @Override
    public void handle(CommandContext ctx) {
        JDA jda = ctx.getJDA();
        jda.getRestPing().queue((ping) -> ctx.getChannel().sendMessageFormat("Rest API Ping: %sms\nWebSocket Ping: %sms", ping, jda.getGatewayPing()).queue());
    }

    @Override
    public String getHelp() {
        return "Shows the current ping from the bot to the Discord servers" +
                "Usage: `" + Config.getConfig().getString("bot.prefix") + "ping`";
    }

    @Override
    public String getName() {
        return "ping";
    }

    @Override
    public void handleSlash(CommandContext ctx) {
        JDA jda = BuzzBot.jda;
        jda.getRestPing().queue(ping -> ctx.getHook().sendMessageFormat("Rest API Ping: %sms\nWebSocket Ping: %sms", ping, jda.getGatewayPing()).queue());
    }

    @Override
    public String getDescription() {
        return "Shows the current ping from the bot to API";
    }

    @Override
    public CommandData getCommandData() {
        return new CommandData(this.getName(), this.getDescription());
    }
}
